---
title: MediaStreamAudioSourceNode()
slug: Web/API/MediaStreamAudioSourceNode/MediaStreamAudioSourceNode
tags:
  - API
  - Audio
  - Constructor
  - MediaStreamAudioSourceNode
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>'s <code><strong>MediaStreamAudioSourceNode()</strong></code> constructor creates and returns a new {{domxref("MediaStreamAudioSourceNode")}} object which uses the first audio track of a given {{domxref("MediaStream")}} as its source.</span></p>

<div class="notecard note">
<p><strong>Note:</strong> Another way to create a <code>MediaStreamAudioSourceNode</code> is to call the{{domxref("AudioContext.createMediaStreamSource()")}} method, specifying the stream from which you want to obtain audio.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>audioSourceNode</em> = new MediaStreamAudioSourceNode(<em>context</em>, <em>options</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>context</code></dt>
 <dd>An {{domxref("AudioContext")}} representing the audio context you want the node to be associated with.</dd>
 <dt><code>options</code></dt>
 <dd>
 <p>A {{domxref("MediaStreamAudioSourceOptions")}} object defining the properties you want the <code>MediaStreamAudioSourceNode</code> to have:</p>

 <p>{{page("/en-US/docs/Web/API/MediaStreamAudioSourceOptions", "Properties")}}</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("MediaStreamAudioSourceNode")}} object representing the audio node whose media is obtained from the specified source stream.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The specified {{domxref("MediaStream")}} doesn't have any audio tracks.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example uses {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} to obtain access to the user's camera, then creates a new {{domxref("MediaStreamAudioSourceNode")}} from its {{domxref("MediaStream")}}.</p>

<pre class="brush: js">// define variables
var audioCtx = new (window.AudioContext || window.webkitAudioContext)();

// getUserMedia block - grab stream
// put it into a MediaStreamAudioSourceNode
if (navigator.mediaDevices.getUserMedia) {
   navigator.mediaDevices.getUserMedia (
      // constraints: audio and video for this app
      {
         audio: true,
         video: false
      }).then(function(stream) {
        var options = {
          mediaStream : stream
        }

        var source = new MediaStreamAudioSourceNode(audioCtx, options);
        source.connect(audioCtx.destination);
      }).catch(function(err) {
       console.log('The following gUM error occurred: ' + err);
      });
} else {
  console.log('new getUserMedia not supported on your browser!');
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API','#dom-mediastreamaudiosourcenode-mediastreamaudiosourcenode','MediaStreamAudioSourceNode()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamAudioSourceNode.MediaStreamAudioSourceNode")}}</p>
